//-------------------------------Server init
 
var express = require('express');
var path = require('path');
//var favicon = require('serve-favicon');
var logger = require('morgan');
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');
var events = require('events');
var rxTx = require('rxTx.js');
var routes = require('./routes/index');
var users = require('./routes/users');

serialport = require("serialport");	// include the serialport library
SerialPort = serialport.SerialPort; // make a local instance of serial

var app = express();

/* ========Copied from bin/www. required if you want to use the old method without www
 * uncomment this
 * delete www
 * launch with "node app.js instead of npm start
http://stackoverflow.com/questions/24609991/using-socket-io-in-express-4-and-express-generators-bin-www
 * Normalize a port into a number, string, or false.
*/
function normalizePort(val) {
  var port = parseInt(val, 10);

  if (isNaN(port)) {
    // named pipe
    return val;
  }

  if (port >= 0) {
    // port number
    return port;
  }

  return false;
}

var port = normalizePort(process.env.PORT || '3333');
app.set('port', port);
/*========Copied from bin/www. required if you want to use the old method without www */

var server = require('http').Server(app);
io = require('socket.io')(server);

/*app.get('/', function(req, res){
  res.sendfile('index.html');
});
*/

server.listen(app.get('port'), function(){
  console.log('Express server listening on port ' + app.get('port'));
});

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'jade');

// uncomment after placing your favicon in /public
//app.use(favicon(__dirname + '/public/favicon.ico'));
app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

app.use('/', routes);
app.use('/users', users);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  var err = new Error('Not Found');
  err.status = 404;
  next(err);
});

// error handlers

// development error handler
// will print stacktrace
if (app.get('env') === 'development') {
  app.use(function(err, req, res, next) {
    res.status(err.status || 500);
    res.render('error', {
      message: err.message,
      error: err
    });
  });
}

// production error handler
// no stacktraces leaked to user
app.use(function(err, req, res, next) {
  res.status(err.status || 500);
  res.render('error', {
    message: err.message,
    error: {}
  });
});

module.exports = app;

upTime = Date.now();

//-------------------------------Websocket
// Add a connect listener
ErrCode = 0;
//Rx.Mode=0; // not yet applicable

io.sockets.on('connection', function(client)
{   // Success!  Now listen to messages to be received
	client.on('message',function(event)
	{ 
	  //console.log("connect"); //debug
      RX = JSON.parse(event);
      //console.log("Address: "+RX.Addr+"  Channel: "+RX.Ch+"  Protocol: "+RX.Prot+"  Data: "+RX.Data);

      if(CommTxStatus == 0)
      {
      	rxTx.ComTx();
      }
      else
      {// previous TX sequence not yet over
      	rxTx.ComResult(6,1);
      }
	});
	
	exports.SendSocket = function()
	{
		var Tx =
		{
		  'error': ErrCode
		};
		client.emit('Result', JSON.stringify(Tx));
	}
	
	client.on('disconnect',function()
	{
		//console.log('Server has disconnected');
	});
});

server.listen(port, function(){
  console.log('listening on *:' + port);
});

//-------------------------------Serial communication
// open the serial port. Change the name to the name of your port,
// "/dev/tty.usbserial-A700ejZq"    // on Mac
// "/dev/ttyS1"                     // on Aria G25
// "/dev/ttyO1"                     // on BeagleBone Black. 
//		Requires before: 
//					cd /lib/firmware
//					sudo echo BB-UART1 > /sys/devices/bone_capemgr.*/slots
//					sudo echo BB-UART2 > /sys/devices/bone_capemgr.*/slots
// or, better, write the line below to /boot/uEnv.txt
// cape_enable=capemgr.enable_partno=BB-UART1,BB-UART2

port2 = "/dev/ttyO2",
bps2 = 19200,
data2 = 8,
par2 = 'none',
stop2 = 1,
flow2 = false;

port1 = "/dev/ttyO1",	
bps1 = 19200,
data1 = 8,
par1 = 'none',
stop1 = 1,
flow1 = false;

Port1 = new SerialPort(port1, 
{ 
  parser: serialport.parsers.readline("\n"),
  baudrate: bps1,
  dataBits: data1, 
  parity: par1, 
  stopBits: stop1, 
  flowControl: flow1
});

Port2 = new SerialPort(port2, 
{ 
  parser: serialport.parsers.readline("\n"),
  baudrate: bps2,
  dataBits: data2, 
  parity: par2, 
  stopBits: stop2, 
  flowControl: flow2
});

Port1.on('open', function()
{
	console.log('Port 1 open: '+port1+
	" bps: "+bps1+
	" data bit: "+data1+
	" parity: "+par1+
	" stop bit: "+stop1+
	" flow control: "+flow1);
   
  OpenFlag1 = 1;
});

Port2.on('open', function()
{
	console.log('Port 2 open: '+port2+
	" bps: "+bps2+
	" data bit: "+data2+
	" parity: "+par2+
	" stop bit: "+stop2+
	" flow control: "+flow2);
  
  OpenFlag2 = 1;
});

Port1.on("data", function (data) 
{ //  
    rxTx.ComRx(data); // analyze received data
});

Port2.on("data", function (data) 
{ //  
    rxTx.ComRx(data); // analyze received data
});

Port1.on('error', function (data) 
{ // call back on error
  console.log("com 1 error" + data);
  console.log("//Requires before: \n cd /lib/firmware \nsudo echo BB-UART1 > /sys/devices/bone_capemgr.*/slots \nsudo echo BB-UART2 > /sys/devices/bone_capemgr.*/slots");
  rxTx.ComResult(8,0);
});

Port2.on('error', function (data) 
{ // call back on error
  console.log("com 2 error" + data);
  console.log("//Requires before: \n cd /lib/firmware \nsudo echo BB-UART1 > /sys/devices/bone_capemgr.*/slots \nsudo echo BB-UART2 > /sys/devices/bone_capemgr.*/slots");
  rxTx.ComResult(8,0);
});
